<?

    /**
     * Graphite
     *
     * Copyright 2005 Scott Reynen
     *
     * This program is free software; you can redistribute it and/or modify
     * it under the terms of the GNU General Public License as published by
     * the Free Software Foundation; either version 2 of the License, or
     * (at your option) any later version.
     * 
     * This program is distributed in the hope that it will be useful,
     * but WITHOUT ANY WARRANTY; without even the implied warranty of
     * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     * GNU General Public License for more details: 
     * <http: *www.gnu.org/licenses/gpl.txt>
     */
	
	$debug = FALSE;
	
	function multiple_strpos( $needle , $haystack ) 
	{
	
		$position = strpos( $haystack , $needle );
		if ( $position === FALSE ) return 0;
		$next_position = strpos( $haystack , $needle , ( $position + strlen( $needle ) ) );
		if ( $next_position === FALSE ) return 1;
		else return 2;
	
	} // multiple_strpos
	
	function minimize_needle( $needle , $haystack )
	{
		
		$size = 1;
		$pos = multiple_strpos( substr( $needle , 0 , $size ) , $haystack );
		
		while ( 
			( $pos > 1 ) &&
			( $size < strlen( $needle ) ) 
		) 
		{
		
			$size++;
			$pos = multiple_strpos( substr( $needle , 0 , $size ) , $haystack );
			
		} // while
		
		if ( $pos == 0 ) return $needle;
		else return substr( $needle , 0 , $size );
	
	} // minimize_needle
	
	function minimize_needle_end( $needle , $haystack )
	{
		
		return strrev( minimize_needle( strrev( $needle ) , strrev( $haystack ) ) );
	
	} // minimize_needle
	
	function unhtmlentities( $string ) 
	{
	
		$string = preg_replace( 
			'~&#x([0-9a-f]+);~ei' , 'chr(hexdec("\\1"))' , $string 
		);
		$string = preg_replace( '~&#([0-9]+);~e', 'chr(\\1)' , $string );
		$trans_tbl = get_html_translation_table( HTML_ENTITIES );
		$trans_tbl = array_flip( $trans_tbl );
		return strtr( $string , $trans_tbl );
		
	} // unhtmlentities

	function custom_strip( $string )
	{
	
		$string = preg_replace( '#&nbsp;#' , ' ' , $string );
		return preg_replace( 
			'#<(style|script)[^>]*>.*?</(style|script)>#i' , '' , $string 
		);
	
	} // strip_style

	$url = $argv[1];

	if ( $debug ) echo( 'getting content' . "\n" );

	$raw_content = file_get_contents( $url );
	
	if ( $debug ) echo( 'got content' . "\n" );
	
	if ( $raw_content === FALSE ) die( '! URL' );
	
	$merge_spaces_content = preg_replace( "#\s+#" , ' ' , $raw_content );
	$no_style_content = custom_strip( $merge_spaces_content );
	$no_html_content = unhtmlentities( strip_tags( $no_style_content ) );
		
	$content = $no_html_content;
	$start_position = 0;
	
	$i = 1;
	$found = array();
	
	if ( $debug ) echo( 'getting plain text' . "\n" );
	
	while ( 
		preg_match( 
			'/[\d]+(?:[\s\.\,]?[\d]+)*/' , $content , $match , 
			PREG_OFFSET_CAPTURE , $start_position 
		) 
	) {
						
		$start_context = $match[0][1] - 12;
		if ( $start_context < 0 ) $start_context = 0;		
		$end_context = $match[0][1] + strlen( $match[0][0] ) + 12;
		if ( $end_context > ( strlen( $content ) - 1 ) )
			$end_context = strlen( $content ) - 1;
		$context_length = $match[0][1] - $start_context;
		$pre = substr( $content , $start_context , $context_length );
		$number = $match[0][0];		
		$start_context = $match[0][1] + strlen( $match[0][0] );
		$context_length = $end_context - $start_context;
		$post = substr( $content , $start_context , $context_length );
		$start_position = $match[0][1] + strlen( $match[0][0] );

		$found[ $i ]['text_pre'] = $pre;
		$found[ $i ]['number'] = $number;
		$found[ $i ]['text_post'] = $post;

		$i++;

	} // while
	
	if ( $debug ) echo( 'got plain text' . "\n" );
	
	$content = $no_style_content;
	$start_position = 0;
	
	$i = 1;
	$found_html = array();
		
	if ( $debug ) echo( 'getting html text' . "\n" );
		
	while ( 
		preg_match( 
			'/[\d]+(?:[\s\.\,]*[\d]+)*/' , $content , $match , 
			PREG_OFFSET_CAPTURE , $start_position 
		) 
	) {

		$start_context = $match[0][1] - 200;
		if ( $start_context < 0 ) $start_context = 0;		
		$end_context = $match[0][1] + strlen( $match[0][0] ) + 200;
		if ( $end_context > ( strlen( $content ) - 1 ) )
			$end_context = strlen( $content ) - 1;
		$context_length = $match[0][1] - $start_context;
		$pre = substr( $content , $start_context , $context_length );
		$number = $match[0][0];		
		$start_context = $match[0][1] + strlen( $match[0][0] );
		$context_length = $end_context - $start_context;
		$post = substr( $content , $start_context , $context_length );
		$start_position = $match[0][1] + strlen( $match[0][0] );

		$found_html[ $i ]['pre'] = $pre;
		$found_html[ $i ]['number'] = $number;
		$found_html[ $i ]['post'] = $post;

		$i++;

	} // while

	if ( $debug ) echo( 'got html text' . "\n" );

	if ( $debug ) echo( 'found_html: ' . count( $found_html ) . ' found: ' . count( $found ) . "\n" );

	$html_key = 0;

	while( list( $key , $val ) = each( $found ) )
	{
	
		if ( $debug ) echo( 'key #' . $key .  "\n" );

	
		$starting_html_key = $html_key;
	
		while (
			( $val['number'] != $found_html[ $html_key ]['number'] ) &&
			( $html_key < count( $found_html ) )
		)
		{
			
			if ( $debug ) echo( 'html_key #' . $html_key .  ' ' . $found_html[ $html_key ]['number'] . "\n" );
			$html_key++;
			
		} // while
	
		if ( $found[ $key ]['number'] == $found_html[ $html_key ]['number'] )
		{
	
			$found[ $key ]['pre'] = minimize_needle_end( $found_html[ $html_key ]['pre'] , $no_style_content );
			$found[ $key ]['post'] = minimize_needle( $found_html[ $html_key ]['post'] , $no_style_content );

		} // if 
		else 
		{
		
			unset( $found[ $key ] );
			$html_key = $starting_html_key;
		
		} // else
		
	} // while
		
	// $found_slice = $found;
		
	$found_slice = array_slice( $found , 0 , 30 );
	
	ob_start();
	
	while( list( , $i ) = each( $found_slice ) )
	{
	
		echo( $i['text_pre'] . '<b>' . $i['number'] . '</b>' );
		echo( $i['text_post'] . "\n" . $i['pre'] . "\n" . $i['post'] . "\n" );
	
	} // while
		
?>